package com.sun.org.omg.SendingContext;

import java.io.ObjectOutputStream;
import java.io.IOException;
import org.omg.CORBA.ORB;
import java.io.ObjectInputStream;
import com.sun.org.omg.SendingContext.CodeBasePackage.ValueDescSeqHelper;
import com.sun.org.omg.CORBA.ValueDefPackage.FullValueDescriptionHelper;
import com.sun.org.omg.CORBA.ValueDefPackage.FullValueDescription;
import com.sun.org.omg.SendingContext.CodeBasePackage.URLSeqHelper;
import com.sun.org.omg.CORBA.RepositoryIdSeqHelper;
import org.omg.CORBA.portable.OutputStream;
import com.sun.org.omg.SendingContext.CodeBasePackage.URLHelper;
import com.sun.org.omg.CORBA.RepositoryIdHelper;
import org.omg.CORBA.portable.InputStream;
import org.omg.CORBA.portable.RemarshalException;
import org.omg.CORBA.portable.ApplicationException;
import org.omg.CORBA.MARSHAL;
import com.sun.org.omg.CORBA.RepositoryHelper;
import com.sun.org.omg.CORBA.Repository;
import org.omg.CORBA.portable.Delegate;
import org.omg.CORBA.portable.ObjectImpl;

public class _CodeBaseStub extends ObjectImpl implements CodeBase
{
    private static String[] __ids;
    
    public _CodeBaseStub() {
    }
    
    public _CodeBaseStub(Delegate delegate) {
        this._set_delegate(delegate);
    }
    
    public Repository get_ir() {
        InputStream inputStream = null;
        try {
            inputStream = this._invoke(this._request("get_ir", true));
            return read = RepositoryHelper.read(inputStream);
        }
        catch (ApplicationException ex) {
            inputStream = ex.getInputStream();
            throw new MARSHAL(ex.getId());
        }
        catch (RemarshalException ex2) {
            return this.get_ir();
        }
        finally {
            this._releaseReply(inputStream);
        }
    }
    
    public String implementation(String s) {
        InputStream inputStream = null;
        try {
            OutputStream request = this._request("implementation", true);
            RepositoryIdHelper.write(request, s);
            inputStream = this._invoke(request);
            return read = URLHelper.read(inputStream);
        }
        catch (ApplicationException ex) {
            inputStream = ex.getInputStream();
            throw new MARSHAL(ex.getId());
        }
        catch (RemarshalException ex2) {
            return this.implementation(s);
        }
        finally {
            this._releaseReply(inputStream);
        }
    }
    
    public String[] implementations(String[] array) {
        InputStream inputStream = null;
        try {
            OutputStream request = this._request("implementations", true);
            RepositoryIdSeqHelper.write(request, array);
            inputStream = this._invoke(request);
            return read = URLSeqHelper.read(inputStream);
        }
        catch (ApplicationException ex) {
            inputStream = ex.getInputStream();
            throw new MARSHAL(ex.getId());
        }
        catch (RemarshalException ex2) {
            return this.implementations(array);
        }
        finally {
            this._releaseReply(inputStream);
        }
    }
    
    public FullValueDescription meta(String s) {
        InputStream inputStream = null;
        try {
            OutputStream request = this._request("meta", true);
            RepositoryIdHelper.write(request, s);
            inputStream = this._invoke(request);
            return read = FullValueDescriptionHelper.read(inputStream);
        }
        catch (ApplicationException ex) {
            inputStream = ex.getInputStream();
            throw new MARSHAL(ex.getId());
        }
        catch (RemarshalException ex2) {
            return this.meta(s);
        }
        finally {
            this._releaseReply(inputStream);
        }
    }
    
    public FullValueDescription[] metas(String[] array) {
        InputStream inputStream = null;
        try {
            OutputStream request = this._request("metas", true);
            RepositoryIdSeqHelper.write(request, array);
            inputStream = this._invoke(request);
            return read = ValueDescSeqHelper.read(inputStream);
        }
        catch (ApplicationException ex) {
            inputStream = ex.getInputStream();
            throw new MARSHAL(ex.getId());
        }
        catch (RemarshalException ex2) {
            return this.metas(array);
        }
        finally {
            this._releaseReply(inputStream);
        }
    }
    
    public String[] bases(String s) {
        InputStream inputStream = null;
        try {
            OutputStream request = this._request("bases", true);
            RepositoryIdHelper.write(request, s);
            inputStream = this._invoke(request);
            return read = RepositoryIdSeqHelper.read(inputStream);
        }
        catch (ApplicationException ex) {
            inputStream = ex.getInputStream();
            throw new MARSHAL(ex.getId());
        }
        catch (RemarshalException ex2) {
            return this.bases(s);
        }
        finally {
            this._releaseReply(inputStream);
        }
    }
    
    public String[] _ids() {
        return (String[])(String[])_CodeBaseStub.__ids.clone();
    }
    
    private void readObject(ObjectInputStream objectInputStream) {
        try {
            this._set_delegate(((ObjectImpl)ORB.init().string_to_object(objectInputStream.readUTF()))._get_delegate());
        }
        catch (IOException ex) {}
    }
    
    private void writeObject(ObjectOutputStream objectOutputStream) {
        try {
            objectOutputStream.writeUTF(ORB.init().object_to_string(this));
        }
        catch (IOException ex) {}
    }
    
    static {
        _CodeBaseStub.__ids = new String[] { "IDL:omg.org/SendingContext/CodeBase:1.0", "IDL:omg.org/SendingContext/RunTime:1.0" };
    }
}
